#include <cstdio>
using namespace std;
typedef long long ll;
constexpr int max_n=1000;
int a[max_n+1],b[max_n+1];
int main(){
	int n,k;
	scanf("%d%d",&n,&k);
	const int lhf=n>>1,rhf=(n+1)>>1;
	for(int i=1; i<=n; ++i)
		scanf("%d",a+i);
	for(int i=1; i<=k; ++i){
		for(int i=1; i<=rhf; ++i)
			b[i]=-a[n-i+1];
		if(rhf>lhf)
			a[n]=b[rhf];
		for(int i=lhf<<1; i; i-=2){
			a[i]=a[i/2];
			a[i-1]=b[i/2];
		}
		for(int i=1; i<=n; ++i)
			printf("%3d ",a[i]);
		puts("");
	}
	return 0;
}
